"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _medias = _interopRequireWildcard(require("./medias"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

var gtKeys = Object.keys(_medias.greaterThanMedias);
var defaultScreenSize = {
  xs: false,
  gtXs: true,
  sm: false,
  gtSm: true,
  md: true,
  gtMd: true,
  lg: false,
  gtLg: false
};

var Provider =
/*#__PURE__*/
function () {
  function Provider(medias, screenSize, matchMedia) {
    var _this = this;

    if (medias === void 0) {
      medias = {};
    }

    if (screenSize === void 0) {
      screenSize = {};
    }

    if (matchMedia === void 0) {
      matchMedia = window.matchMedia;
    }

    this.listeners = [];
    this.medias = Object.assign({}, _medias.default, medias);
    this.screenSize = Object.assign({}, defaultScreenSize, screenSize);
    this.mediaQueryLists = {};
    Object.keys(this.medias).forEach(function (key) {
      _this.mediaQueryLists[key] = matchMedia(_this.medias[key]);
    });
    gtKeys.forEach(function (key) {
      _this.mediaQueryLists[key].addListener(function () {
        return _this.update();
      });
    });
  }

  var _proto = Provider.prototype;

  _proto.getScreenSize = function getScreenSize() {
    return this.screenSize;
  };

  _proto.update = function update() {
    var _this2 = this;

    this.screenSize = Object.assign({}, this.screenSize);
    Object.keys(this.screenSize).forEach(function (key) {
      _this2.screenSize[key] = _this2.mediaQueryLists[key].matches;
    });
    this.listeners.forEach(function (listener) {
      return listener();
    });
  };

  _proto.subscribe = function subscribe(listener) {
    var _this3 = this;

    this.listeners.push(listener);
    return function () {
      _this3.listeners.splice(_this3.listeners.indexOf(listener), 1);
    };
  };

  return Provider;
}();

var _default = Provider;
exports.default = _default;